<template>
  <div class="p-2">
    <el-row :gutter="10">
      <el-col :span="5">
        <el-card>
          <template #header>
            <div class="card-header">分项系统</div>
          </template>
          <div>
            <el-input v-model="filterText" style="width: 200px" placeholder="请输入关键字" />
            <el-tree ref="treeRef" style="max-width: 600px; margin-top: 5px" class="filter-tree" :props="defaultProps"
              :data="treeData" node-key="id" default-expand-all highlight-current :expand-on-click-node="false"
              :filter-node-method="filterNode" @node-click="handleNodeClick" />
          </div>
        </el-card>
      </el-col>
      <el-col :span="19">
        <transition :enter-active-class="proxy?.animate.searchAnimate.enter"
          :leave-active-class="proxy?.animate.searchAnimate.leave">
          <div v-show="showSearch" class="mb-[10px]">
            <el-card shadow="hover">
              <el-form ref="queryFormRef" :model="queryParams" :inline="true" label-width="100px">
                <el-form-item label="设备类型名称" prop="deviceTypeId">
                  <el-select v-model="queryParams.deviceTypeId" placeholder="请选择设备类型名称">
                    <el-option v-for="dict in dictGroup.deviceTypeOptions" :key="dict.id" :label="dict.name"
                      :value="dict.id"></el-option>
                  </el-select>
                </el-form-item>
                <el-form-item label="型号" prop="xh">
                  <el-input v-model="queryParams.xh" placeholder="请输入型号" clearable @keyup.enter="handleQuery" />
                </el-form-item>
                <el-form-item>
                  <el-button type="primary" icon="Search" @click="handleQuery"> 搜索 </el-button>
                  <el-button icon="Refresh" @click="resetQuery"> 重置 </el-button>
                </el-form-item>
              </el-form>
            </el-card>
          </div>
        </transition>

        <el-card shadow="never">
          <template #header>
            <el-row :gutter="10" class="mb8">
              <el-col :span="1.5">
                <el-button type="primary" plain icon="Plus" @click="handleAdd"> 新增 </el-button>
              </el-col>
              <el-col :span="1.5">
                <el-button type="success" plain icon="Edit" :disabled="single" @click="handleUpdate"> 修改 </el-button>
              </el-col>
              <el-col :span="1.5">
                <el-button type="danger" plain icon="Delete" :disabled="multiple" @click="handleDelete"> 删除 </el-button>
              </el-col>
              <right-toolbar v-model:showSearch="showSearch" @query-table="getList" />
            </el-row>
          </template>

          <el-table v-loading="loading" :data="deviceTypeList" @selection-change="handleSelectionChange">
            <el-table-column type="selection" width="55" align="center" />
            <el-table-column label="设备名称" align="center">
              <template #default="scope">
                {{ formatDict(scope.row.deviceTypeId, 'deviceTypeOptions') }}
              </template>
            </el-table-column>
            <el-table-column label="品牌" align="center" prop="ext1.brand" />
            <el-table-column label="型号" align="center" prop="xh" />
            <el-table-column label="供应商" align="center" prop="productorId">
              <template #default="scope">
                {{ formatDict(scope.row.productorId, 'productorOptions') }}
              </template>
            </el-table-column>
            <el-table-column label="联系人" align="center" prop="ext1.linkName" />
            <el-table-column label="联系方式" align="center" prop="ext1.linkPhone" width="120" />
            <el-table-column label="备注" align="center" prop="remark" />
            <el-table-column label="创建时间" align="center" prop="createTime" width="160" />
            <el-table-column label="操作" align="center" width="120" fixed="right" class-name="small-padding fixed-width">
              <template #default="scope">
                <el-button v-hasPermi="['jdyw:deviceType:edit']" size="small" link type="primary"
                  @click="handleUpdate(scope.row)">修改</el-button>
                <el-button v-hasPermi="['jdyw:deviceType:remove']" size="small" link type="danger"
                  @click="handleDelete(scope.row)">删除</el-button>
              </template>
            </el-table-column>
          </el-table>
          <pagination v-show="total > 0" v-model:page="queryParams.pageNum" v-model:limit="queryParams.pageSize"
            :total="total" @pagination="getList" />
        </el-card>
      </el-col>
    </el-row>

    <!-- 添加或修改设备类型信息对话框 -->
    <el-dialog v-model="dialog.visible" :title="dialog.title" width="500px" append-to-body>
      <el-form ref="deviceTypeFormRef" :model="form" label-width="110px">
        <el-form-item label="设备类型名称" prop="deviceTypeId"
          :rules="[{ required: true, message: '设备类型名称不能为空', trigger: 'change' }]">
          <el-select v-model="form.deviceTypeId" placeholder="请选择设备类型名称">
            <el-option v-for="dict in dictGroup.deviceTypeOptions" :key="dict.id" :label="dict.name"
              :value="dict.id"></el-option>
          </el-select>
        </el-form-item>
        <el-form-item label="品牌" prop="ext1.brand" :rules="[{ required: true, message: '品牌不能为空', trigger: 'blur' }]">
          <el-input v-model="form.ext1.brand" placeholder="请输入品牌" />
        </el-form-item>
        <el-form-item label="型号" prop="xh" :rules="[{ required: true, message: '型号不能为空', trigger: 'blur' }]">
          <el-input v-model="form.xh" placeholder="请输入型号" />
        </el-form-item>
        <el-form-item label="供应商" prop="productorId"
          :rules="[{ required: true, message: '供应商不能为空', trigger: 'change' }]">
          <el-select v-model="form.productorId" clearable placeholder="请选择供应商" @change="setProductorInfo">
            <el-option v-for="dict in dictGroup.productorOptions" :key="dict.id" :label="dict.name"
              :value="dict.id"></el-option>
          </el-select>
        </el-form-item>
        <el-form-item label="供应商联系人" prop="ext1.linkName">
          <el-input v-model="form.ext1.linkName" disabled />
        </el-form-item>
        <el-form-item label="联系电话" prop="ext1.linkPhone">
          <el-input v-model="form.ext1.linkPhone" disabled />
        </el-form-item>
        <el-form-item label="备注" prop="remark">
          <el-input v-model="form.remark" type="textarea" placeholder="请输入备注" />
        </el-form-item>
      </el-form>
      <template #footer>
        <div class="dialog-footer">
          <el-button :loading="buttonLoading" type="primary" @click="submitForm"> 确 定 </el-button>
          <el-button @click="cancel"> 取 消 </el-button>
        </div>
      </template>
    </el-dialog>
  </div>
</template>

<script setup name="VersionManage" lang="ts">
import {
  listDeviceType,
  getDeviceTypeDetail,
  delDeviceTypeDetail,
  addDeviceTypeDetail,
  updateDeviceTypeDetail,
  getDeviceSystemTree,
  getDeviceTypeDetailList
} from '@/api/deviceManage/deviceType';
import { listProductor } from '@/api/supplierManage/index';
import { deepClone } from '@/utils/index';
const { proxy } = getCurrentInstance() as ComponentInternalInstance;
const deviceTypeList = ref([]);
const buttonLoading = ref(false);
const loading = ref(true);
const showSearch = ref(true);
const ids = ref<Array<string | number>>([]);
const single = ref(true);
const multiple = ref(true);
const total = ref(0);
const queryFormRef = ref<ElFormInstance>();
const deviceTypeFormRef = ref<ElFormInstance>();
const filterText = ref('');
const treeRef = ref<ElTreeInstance>();
const filterNode = (value: string, data) => {
  if (!value) return true;
  return data.name.includes(value);
};
watch(filterText, (val) => {
  treeRef.value!.filter(val);
});
const defaultProps = {
  children: 'children',
  label: 'name'
};
const treeData = ref([]);
const dialog = reactive<DialogOption>({
  visible: false,
  title: ''
});
const dictGroup = reactive({
  deviceTypeOptions: [],
  productorOptions: []
});
const initFormData = {
  id: undefined,
  productorId: '',
  deviceTypeId: undefined,
  xh: null,
  remark: undefined,
  ext1: <any>{
    brand: undefined,
    linkName: '',
    linkPhone: ''
  },
  ext2: undefined
};
const formData = reactive({
  form: { ...initFormData },
  queryParams: {
    pageNum: 1,
    pageSize: 10,
    systemId: undefined,
    deviceTypeId: undefined,
    xh: undefined,
    params: {}
  }
});

const { queryParams, form } = toRefs(formData);
/** 查询设备类型信息列表 */
const getList = async () => {
  loading.value = true;
  const res = await getDeviceTypeDetailList(queryParams.value);
  deviceTypeList.value = res.rows.map((item) => ({
    ...item,
    ext1: item.ext1 ? JSON.parse(item.ext1) : null
  }));
  total.value = res.total;
  loading.value = false;
};

/** 取消按钮 */
const cancel = () => {
  reset();
  dialog.visible = false;
};

/** 表单重置 */
const reset = () => {
  form.value = deepClone(initFormData);
  deviceTypeFormRef.value?.resetFields();
};

/** 搜索按钮操作 */
const handleQuery = () => {
  queryParams.value.pageNum = 1;
  getList();
};

/** 重置按钮操作 */
const resetQuery = () => {
  queryFormRef.value?.resetFields();
  handleQuery();
};

/** 多选框选中数据 */
const handleSelectionChange = (selection) => {
  ids.value = selection.map((item) => item.id);
  single.value = selection.length != 1;
  multiple.value = !selection.length;
};

/** 新增按钮操作 */
const handleAdd = () => {
  reset();
  dialog.visible = true;
  dialog.title = '新增品牌型号';
};

/** 修改按钮操作 */
const handleUpdate = async (row) => {
  reset();
  const _id = row?.id || ids.value[0];
  const res = await getDeviceTypeDetail(_id);
  res.data.ext1 = res.data.ext1 && JSON.parse(res.data.ext1);
  Object.assign(form.value, res.data);
  dialog.visible = true;
  dialog.title = '修改品牌型号';
};

/** 提交按钮 */
const submitForm = () => {
  deviceTypeFormRef.value?.validate(async (valid: boolean) => {
    if (valid) {
      buttonLoading.value = true;
      const { ext1 } = form.value;
      const params = Object.assign(form.value, { ext1: JSON.stringify(ext1) });
      if (form.value.id) {
        await updateDeviceTypeDetail(params).finally(() => (buttonLoading.value = false));
      } else {
        await addDeviceTypeDetail(params).finally(() => (buttonLoading.value = false));
      }
      proxy?.$modal.msgSuccess('操作成功');
      dialog.visible = false;
      await getList();
    }
  });
};

/** 删除按钮操作 */
const handleDelete = async (row) => {
  const _ids = row?.id || ids.value;
  await proxy?.$modal.confirm('是否确认删除？').finally(() => (loading.value = false));
  await delDeviceTypeDetail(_ids);
  proxy?.$modal.msgSuccess('删除成功');
  await getList();
};

const getTreeData = async () => {
  getDeviceSystemTree({}).then(({ code, rows }) => {
    if (code === 200) {
      treeData.value = convertToTree(rows);
      if (treeData.value.length === 0) {
        treeData.value = [];
      }
    }
  });
};
const convertToTree = (list) => {
  let map = new Map();
  let root = [];
  for (let item of list) {
    map.set(item.id, { ...item });
  }
  for (let item of list) {
    if (item.parentId !== 0) {
      let parent = map.get(item.parentId);
      if (!parent.children) {
        parent.children = [];
      }
      parent.children.push(map.get(item.id));
    } else {
      root.push(map.get(item.id));
    }
  }
  return root;
};
const findNameWithParents = (data, idToFind, parentName = '') => {
  for (let item of data) {
    let fullName = parentName ? `${parentName}/${item.name}` : item.name;
    if (item.id === idToFind) {
      return fullName;
    }
    if (item.children && Array.isArray(item.children)) {
      let result = findNameWithParents(item.children, idToFind, fullName);
      if (result) {
        return result;
      }
    }
  }
  return null; // 如果没有找到对应的 ID，则返回 null
};
const getDeviceTypeList = () => {
  listDeviceType({}).then(({ code, rows }) => {
    if (code === 200) {
      dictGroup.deviceTypeOptions = rows;
    }
  });
};
const getProductorList = () => {
  listProductor({}).then(({ code, rows }) => {
    if (code === 200) {
      dictGroup.productorOptions = rows;
    }
  });
};
const setProductorInfo = (val) => {
  const [{ contact, phone }] = dictGroup.productorOptions.filter((item) => item.id === val);
  form.value.ext1.linkName = contact;
  form.value.ext1.linkPhone = phone;
};
const handleNodeClick = (data, node) => {
  queryParams.value.systemId = data.id;
  handleQuery();
};
const formatDict = (val, option: string) => {
  let label = '';
  dictGroup[option].forEach((item) => {
    if (val === item.id) {
      label = item.name;
    }
  });
  return label;
};
onMounted(() => {
  getList();
  getTreeData();
  getDeviceTypeList();
  getProductorList();
});
</script>
<style lang="scss" scoped></style>
